
import java.util.*;

abstract class robot implements dynamicObject, activeObject, describableObject{
   public robot() {
   }

   public void setPreDefActions() {
      predefActions =  new ArrayList<action>();
      predefActions.add((action) new move(30,1));

      // To be completed
   }

   public void actuation(){
      perceive();
      decide();
      execute();

   }

   public String getState() {
      // To be coded
   }

   void perceive() {
      // Compute sensing (not in use yet)
   }

   void decide() {
      // Select current action
      if(predefActions != null && !predefActions.isEmpty()) {
         if (currentAction == null) {
            currentAction = predefActions.get(0);
            predefActions.remove(0);
         }
      }
      else if (currentAction == null) currentAction = (action) new stop();
   }

   void execute() {
      // Performs action until it ends

      linearVelocity = currentAction.linearVelocity;
      angularVelocity = currentAction.angularVelocity;

      // Initializing action
      if (!currentAction.hasStarted()) {
         currentAction.start(currentPose);
      }

      // Forces to stop if the action is done
      if (currentAction.isDone(currentPose)) {
         currentAction = (action) new stop();
      }
      // Set wheel speeds by computing inverse kinematics
      computeInverseKinematics();

      // Takes out current action to continue when deciding
      if (currentAction.isDone(currentPose)) {
         currentAction = null;
      }
   }

   abstract void computeInverseKinematics();
      
   ArrayList<action> predefActions;
   pose currentPose = new pose();
   double linearVelocity;
   double angularVelocity;
   action currentAction;
}



class pose {
   public double x;
   public double y;
   public double theta;

   public void move(double step, double linearVelocity, double angularVelocity) {
      // To be coded
      // dx = dt * V * cos(o)
      // dy = dt * V * sin(o)
      // do = dt * O
   }
}


abstract class action {
   double linearVelocity;
   double angularVelocity;
   boolean started = false;

   public abstract boolean isDone(pose p);

   public void start(pose startingPose) {
      started = true;
   }

   public boolean hasStarted() {
      return started;
   }
}

class turn extends action {
   public turn(double turningTheta) {
      linearVelocity = 0.0;
      angularVelocity = Math.PI;
      if (turningTheta < 0)
         angularVelocity *= -1;

      turningAngle = Math.abs(turningTheta) % (2.0*Math.PI);

   }

   public void start(pose startingPose) {
      super.start(startingPose); 

      // To be coded (thought to store relevant data of the initial position)
   }

   public boolean isDone(pose p) {
      // To be coded
      // For an absolute difference of angles between 0 and PI, you can use the following relation:
      // delta_angle = PI - | |angle_f - angle_i|%2PI - PI |
   }

   double theta_0;
   double turningAngle;
}

class move extends action {
   public move(double distance, double vel) {
      linearVelocity = vel;
      angularVelocity = 0.0;
      movingDistance = distance;

   }

   public void start(pose startingPose) {
      super.start(startingPose);

      // To be coded (thought to store relevant data of the initial position)
   }

   public boolean isDone(pose p) {
      // To be coded
      
   }

   double x_0;
   double y_0;
   double movingDistance;
}

class stop extends action {
   public boolean isDone(pose p) {
      // To be coded
   }
}